//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_start.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

int t_group_number = 0;
int ct_group_number = 0;
int number_names = 0;
player_t bots[33];  // max of 32 bots in a game

void OrganizeGroup(player_t *pBot)
{
   //This is for organizing group specified by bot_group parameter
   //This is for Terrorisst team
   if ((t_group_number < plb_group->value) && (pBot->player_team & CLIENT_TERRORIST))
   {
      t_group_number++;
      if (Chance(2))
      {
         //Well all what we need is to give ability bot say "COVER ME" ;D
         pBot->say_radio |= RADIO_COVERME;
         pBot->say_time = gpGlobals->time + RANDOM_FLOAT(0.4, 0.7);
      }
   }
   else if ((ct_group_number < plb_group->value) && (pBot->player_team & CLIENT_CT))
   {
      ct_group_number++; //For Counter-Terrorist team
      if (Chance(2))
      {
         //Well all what we need is to give ability bot say "COVER ME" ;D
         pBot->say_radio |= RADIO_COVERME;
         pBot->say_time = gpGlobals->time + RANDOM_FLOAT(0.4, 0.7);
      }
   }
}

void BotSpawnInit( player_t *pBot, int spawn_state )
{
   pBot->is_shooting = 0;
   pBot->shoot_time = 0.0;
   pBot->buy_time = gpGlobals->time;
   pBot->check_stuck_time = gpGlobals->time;
   pBot->hostage_use = 0;
   pBot->curr_hostage = -1;
   pBot->user_gogogo_time = gpGlobals->time;
   pBot->can_drop_weapon = FALSE;
   pBot->currentNodes = NULL;
   pBot->pHelpme = NULL;
   pBot->pGroundWeapon = NULL;
   pBot->vecHoldPosition = g_vecZero;
   pBot->inbombzone = FALSE;
   pBot->inbuyzone = FALSE;
   pBot->last_enemy_point = g_vecZero;
   pBot->v_prev_origin = g_vecZero;
   pBot->visible_alies_number = 0;
   pBot->visible_enemy_number = 0;
   pBot->trEnemy = g_vecZero;
   pBot->update_enemy_time = gpGlobals->time;
   pBot->say_radio = RADIO_NOMSG;
   pBot->user_action = USER_NOACTION;
   pBot->check_grenade = gpGlobals->time;
   pBot->throw_direction = g_vecZero;
   pBot->bot_see_dead_time = -1;
   pBot->bot_see_enemy_time = 0.0;
   pBot->bot_chat = gpGlobals->time + RANDOM_LONG(8,32);

   pBot->look_around_time = gpGlobals->time;
   pBot->avoid_time = gpGlobals->time - 1;
   pBot->action_time = 0.0;
   pBot->check_action_time = 0.0;
   pBot->prev_time = gpGlobals->time + 5.0;
   pBot->blinded_time = 0.0;
   pBot->weap_change_time = 0.0;
   pBot->checkground_time = gpGlobals->time + 10.0;
   pBot->bot_notice_enemy_time = 0.0;
   pBot->moved_distance = 50.0;
   pBot->zoom_fov = 90;
   pBot->look_around_time = gpGlobals->time;
   pBot->ladder_dir = LADDER_DOWN;
   pBot->planedGoal = NULL;
   pBot->bot_action = BOT_NOACTION; //Remove any actions

   //Angles for body and gun...

   if (spawn_state == RESPAWN_INITIALIZE)
   {
      pBot->buy_state = 0;
      pBot->player_team = CLIENT_UNKNOW;
      pBot->pBotEnemy = NULL;

      pBot->msecnum = 0;
      pBot->msecdel = 0.0;
      pBot->msecval = 0.0;
      pBot->flags = 0;

      pBot->bot_killchat = -1;
      pBot->bot_deadchat = -1;

      pBot->start_action = MSG_CS_TEAM_SELECT;
      pBot->not_started = FALSE;
      pBot->not_started = TRUE; // hasn't joined game yet
      pBot->bot_money = 0;

      pBot->flags |= FL_FAKECLIENT;
      pBot->pEdict->v.flags |= FL_FAKECLIENT;
      pBot->pEdict->v.solid = 1;//SOLID_SLIDEBOX;
      pBot->pEdict->v.idealpitch = pBot->pEdict->v.v_angle.x;
      pBot->pEdict->v.ideal_yaw = pBot->pEdict->v.v_angle.y;
      pBot->pEdict->v.pitch_speed = 25;
      pBot->pEdict->v.yaw_speed = 25;

      if (plb_skill->value==6)
         pBot->bot_skill = RANDOM_LONG(1,5);
      else if (plb_skill->value<1||plb_skill->value>5)
         pBot->bot_skill = plb_skill->value;

      pBot->bot_class = -1;
      //Initialize weapons and ammo array
      memset(&(pBot->current_weapon), 0, sizeof(pBot->current_weapon));
      memset(&(pBot->m_rgAmmo), 0, sizeof(pBot->m_rgAmmo));
   }
   else if (spawn_state == RESPAWN_START_ROUND)
   {
      OrganizeGroup(pBot); //Random decide if bot call for creating team
      NullLastGoals(pBot);
      FreeHostage(-1); //Free all hostages
      pBot->avoid_angle = pBot->pEdict->v.angles;
      pBot->avoid_angle.x = 0; //Reset veritical pos.
      pBot->ideal_body = pBot->pEdict->v.angles.y;
      pBot->ideal_bodyx = 0; //Reset veritical pos.
      pBot->avoid_angle = pBot->pEdict->v.angles;
      pBot->avoid_angle.x = 0;
      pBot->rush_time = gpGlobals->time + 15.0;
      pBot->pBotEnemy = NULL;
      pBot->botcontrol = 0;
      if (rushpoint_num > 0)
         pBot->planedGoal = rushpoint[RANDOM_LONG(0,rushpoint_num - 1)].pEdict;
      pBot->buy_time = gpGlobals->time + 2.0;
   }
   else if (spawn_state == RESPAWN_END_ROUND)
   {
      pBot->action_time = gpGlobals->time + 5.0;
      pBot->prev_time = gpGlobals->time + 20.0;
      pBot->buy_time = gpGlobals->time + 7.0;
   }
}

extern int prev_nick;

char *BotPickName(int max_num)
{
   if (!max_num)
      return "PLBot";

   int name_index, attempts = 0;
   edict_t *pPlayer = NULL;

search:// check make sure this name isn't used
   name_index = RANDOM_LONG(1, max_num) - 1; //Get random name

   for (int index = 1; index <= gpGlobals->maxClients; index++)
   {
      pPlayer = INDEXENT(index);

      if (IsValidPlayer(pPlayer) && (FStrEq(bot_names[name_index].name, STRING(pPlayer->v.netname))))
      {
         attempts++; //Save attempts time
         if (attempts < max_num*3)
            goto search;
      }
   }

   return bot_names[name_index].name;
}

void BotCreate( edict_t *pPlayer, const char *arg1, const char *arg2)
{
   edict_t *BotEnt = NULL;
   const char *c_name = BotPickName(prev_nick);
   //Crates fake client with name
   BotEnt = CREATE_FAKE_CLIENT(c_name);
   //Null edict so can't create
   if (FNullEnt( BotEnt ))
   {
      SERVER_PRINT("Max. Players reached. Can't add more bots.\n");
      return; //Well don't initialize any bot
   }
   if (BotEnt->pvPrivateData != NULL)
      FREE_PRIVATE(BotEnt);
   BotEnt->pvPrivateData = NULL;
   // create the player entity by calling MOD's player function (from LINK_ENTITY_TO_CLASS)
   CALL_GAME_ENTITY(PLID, "player", VARS(BotEnt));
   //Get bot info buffor
   char *infobuffer = GET_INFOKEYBUFFER( BotEnt );
   int clientIndex = ENTINDEX( BotEnt );
   // initialize all the variables for this bot
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "rate", "35.000000");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_updaterate", "20");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_lw", "1");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_lc", "1");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "tracker", "0");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "cl_dlmax", "128");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "lefthand", "1");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "friends", "0");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "dm", "0");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "_ah", "1");
   SET_CLIENT_KEYVALUE( clientIndex, infobuffer, "_vgui_menus", "1");
   char szRejectReason[128];
   MDLL_ClientConnect( BotEnt, c_name, "127.0.0.1", szRejectReason );
   MDLL_ClientPutInServer( BotEnt );
   bots[clientIndex].bot_skill = (arg2&&*arg2)?atoi(arg2):plb_skill->value;
   bots[clientIndex].who_have_join = (arg1&&*arg1)?atoi(arg1):-1;
   BotSpawnInit(&bots[clientIndex], RESPAWN_INITIALIZE);
}

